-----------------------------------------------------------------------------------------------
-- Client Lua Script for PowerView
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- PowerView Module Definition
-----------------------------------------------------------------------------------------------
local PowerView = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function PowerView:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	
    return o
end

function PowerView:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- PowerView OnLoad
-----------------------------------------------------------------------------------------------
function PowerView:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("PowerView.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- PowerView OnDocLoaded
-----------------------------------------------------------------------------------------------
function PowerView:OnDocLoaded()
	
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    PowerView.wndMain = Apollo.LoadForm(self.xmlDoc, "PowerViewForm", nil, self)
		if PowerView.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
		Apollo.RegisterSlashCommand("powerview", "OnPowerViewOn", self)
		Apollo.RegisterSlashCommand("pwv", "OnPowerViewOn", self)
		Apollo.RegisterSlashCommand("pvchar", "OnPowerViewCharOn", self)
		
		Apollo.RegisterEventHandler("OpenPowerViewMini", "OnPowerViewMiniOn", self)
		Apollo.RegisterEventHandler("ClosePowerViewMini", "OnPowerViewMiniOff", self)
		
		Character = Apollo.GetAddon("Character")
		Inspect = Apollo.GetAddon("Inspect")
		
		PowerView.wndCharMini = Apollo.LoadForm(self.xmlDoc, "PowerViewMini", Character.wndChracter, self)
		PowerView.wndCharMini:Show(false, true)
		self.wndMain:FindChild("Title"):SetText("PowerView v1.3a") --Version de l'addon
		--PowerView:OnRefresh()			
		end
		function Character:OnToggleCharacterWindow()
			if not self.wndCharacter:IsVisible() then 
				self:ShowCharacterWindow()
				Event_FireGenericEvent("OpenPowerViewMini")
			else
				self.wndCharacter:Show(false)
				Event_FireGenericEvent("CharacterWindowHasBeenClosed")
				Event_FireGenericEvent("ClosePowerViewMini")
				Sound.Play(Sound.PlayUI01ClosePhysical)
			end
		end
		
		function Character:OnClose()
			self.wndCharacter:Show(false)
			Event_FireGenericEvent("CharacterWindowHasBeenClosed")
			Event_FireGenericEvent("ClosePowerViewMini")
		end	
	    self.wndMain:Show(false)
		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		
		-- Do additional Addon initialization here
				
end

-- Unit:GetEquippedItems:GetIt

-----------------------------------------------------------------------------------------------
-- PowerView Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/powerview"
function PowerView:OnPowerViewOn()
	PowerView:OnRefresh()
	PowerView.wndMain:Invoke() -- show the window
end
	
		
function PowerView:OnPowerViewCharOn ()
	self.wndChar:Show(true)
end

function PowerView:OnPowerViewCharOn ()
	self.wndChar:Invoke ()
end
function PowerView:OnPowerViewMiniOn ()
	PowerView:OnRefresh()
	local left, top, right, bottom = Character.wndCharacter:GetAnchorOffsets()
	local leftP, topP, rightP, bottomP = Character.wndCharacter:GetAnchorPoints()
	self.wndCharMini:SetAnchorPoints(leftP, topP, rightP, bottomP)
	self.wndCharMini:SetAnchorOffsets(left+250,top+500,right-350,bottom-180)--La zone doit faire 150x50
	self.wndCharMini:Invoke()
end

function PowerView:OnPowerViewMiniOff ()
	self.wndCharMini:Close()
end

function PowerView:OnRefresh()
			if GameLib.GetPlayerUnit() then --ce if verifie que le joueur est charg
	   			 self.timerInit = nil
			else
				-- restart timer
				self.timerInit = ApolloTimer.Create(1, false, "OnInitDelay", self)
				return
			end

			local drPlayer = GameLib.GetPlayerUnit()
			local strName = drPlayer and drPlayer:GetName()
			PowerView.wndMain:FindChild("name"):SetText(strName)
			
			local strLevel = drPlayer and drPlayer:GetLevelString ()
			PowerView.wndMain:FindChild("level"):SetText(strLevel)
			local numClass = drPlayer:GetClassId()
			--local textClass = drPlayer:GetClassName(numClass)
			PowerView.wndMain:FindChild("class"):SetText(numClass)
			local tableItem = drPlayer:GetEquippedItems ()
			local classPlayer = drPlayer:GetClassId()
			
			--Rinitialisation
			tableErreur = {}
			powerTotal = 0
			PowerView.wndMain:FindChild("contourErrors"):SetSprite("")
			PowerView.wndMain:FindChild("contourErrors"):FindChild("dispErrors"):SetSprite("")
			PowerView.wndMain:FindChild("contourErrors"):FindChild("dispErrors"):SetTooltip("")
			PowerView.wndCharMini:FindChild("contourMini"):FindChild("dispErrors"):SetSprite("")
			PowerView.wndCharMini:FindChild("contourMini"):FindChild("dispErrors"):SetTooltip("")

			for i = 1,14 do -- Dresse la liste des items quips et affiche leur power
				PowerView.wndMain:FindChild("item"..i):SetText("")
				PowerView.wndMain:FindChild("item"..i.."_power"):SetText("")
				if nPixieId == nil then
						self.wndMain:FindChild("item"..i):DestroyAllPixies()
				end

				if tableItem[i] ~= nil and tableItem[i]:GetItemCategory() ~= 88 then--and tableItem[i]:GetItemCategory() ~= 7 and tableItem[i]:GetItemCategory() ~= 116 and tableItem[i]:GetItemCategory() ~= 117 and tableItem[i]:GetItemCategory() ~= 106 then
					--if tableItem[i]:
					local itemName = tableItem[i]:GetName() or "Erreur"
					itemType = --[[tableItem[i]:GetItemTypeName()]] tableItem[i]:GetSlotName()
					local itemQuality = tableItem[i]:GetItemQuality ()
					
					
					if itemQuality == 1 then
						itemColor = "grey"
					elseif itemQuality == 2 then
						itemColor = "ItemQuality_Average"
					elseif itemQuality == 3 then
						itemColor = "ItemQuality_Good"
					elseif itemQuality == 4 then
						itemColor = "ItemQuality_Excellent"
					elseif itemQuality == 5 then
						itemColor = "ItemQuality_Superb"
					elseif itemQuality == 6 then
						itemColor = "ItemQuality_Legendary"
					elseif itemQuality == 7 then
						itemColor = "ItemQuality_Artifact"
					else itemColor = "red"
					end
					
					local itemPower = tableItem[i]:GetItemPower()
					
					self.wndMain:FindChild("item"..i):SetText(itemType.. " : " .. itemName)
					self.wndMain:FindChild("item"..i):SetTextColor(itemColor)
					powerTotal = powerTotal+itemPower
					self.wndMain:FindChild("item"..i.."_power"):SetText(itemPower)
					
					testSprite = {}
					tableStat = {}
					
					testSprite[i]= "Crafting_CircuitSprites:sprCircuit_Line_GreenHorizontal"
					statContraire = 0
					if tableItem[i]:GetItemFamily() ~= 26 and tableItem[i]:GetItemFamily() ~= 28 and tableItem[i]:GetItemType() ~= 300 then
						local fullInfo = tableItem[i]:GetDetailedInfo()
						bonuses = fullInfo.tPrimary.arBudgetBasedProperties
						if bonuses ~= nil then
							for key, value in pairs(bonuses) do -- On prend chaque stat
								propId = value.eProperty 
								propValue = value.nValue
								
								tableStat = value.arDerived
								if tableStat ~= nil then --Si l'objet ne comporte pas de carac du type Mojo
									for key, value in pairs(tableStat) do
										propId = value.eProperty
										propValue = value.nValue
									end
								end
								--else
									--statId = value.
								if propId == 35 or propId == 36 then
									if statContraire == nil then
										statContraire = 0
										totalErreur = 1
									elseif statContraire >= 1 then --Ce qui s'affiche quand l'item a des stats contradictoires
										testSprite[i] = "Crafting_CircuitSprites:sprCircuit_Line_RedHorizontal"
										PowerView.wndMain:FindChild("item"..i):SetTooltip("There are incoherent stats for your class on this item. This item gives Assault Power and Support Power")
										tableErreur[i] = 1

									elseif statContraire <= 0 then
										statContraire = statContraire + 1
									end
								end
								--[[if tableErreur[i] ~= nil then Pour vrifier que la table contient qqchose
									PowerView.wndMain:FindChild("item"..i):SetText(tableErreur[i])
								end	]]					
							end
						end
					end
					for key, value in pairs (tableErreur) do
						local contourErrors = PowerView.wndMain:FindChild("contourErrors")
						local dispErrors = PowerView.wndMain:FindChild("contourErrors"):FindChild("dispErrors")
						if value == 1 then
							contourErrorsSprite = "CRB_ActionBarIconSprites:sprAS_Prompt_Interrupt"
							dispErrorsSprite = "ClientSprites:sprItem_NewQuest"
							dispErrors:SetTooltip("Your equipment is incoherent for your class.")
							textChatErrors = " but contains incoherent stats."
							PowerView.wndCharMini:FindChild("contourMini"):FindChild("dispErrors"):SetSprite("ClientSprites:sprItem_NewQuest")
							PowerView.wndCharMini:FindChild("contourMini"):FindChild("dispErrors"):SetTooltip("At least one of your items is not suitable for your class.")
						else
							textChatErrors = ""
						end
						contourErrors:SetSprite(contourErrorsSprite)
						dispErrors:SetSprite(dispErrorsSprite)
						
					end
					--[[if statContraire == 1 then
						testSprite = "Crafting_CircuitSprites:sprCircuit_Line_RedHorizontal"
					else 
						testSprite = "Crafting_CircuitSprites:sprCircuit_Line_GreenHorizontal"--"CRB_Basekit:kitIcon_Gold_HazardGeneral"
					end]]--
					local nPixieId = self.wndMain:FindChild("item"..i):AddPixie({
  						nil,
 						nil,
 						bLine = false,
						strSprite = testSprite[i],
  						nil,
  						loc = {
   							fPoints = {0.8,-0.0,0.8,-0.0},
    						nOffsets = {0,-7, 50, 42}
  						},
  						flagsText = {
    						DT_CENTER = true,
    						DT_VCENTER = true
  						}
					})
					

					--self.wndMain:FindChild("item"..i):SetTooltip("Lol")
					
				end
			end
				if powerTotal < 10000 then
				powerColor = "ItemQuality_Inferior"
				nextQuality = 10000
				prevQuality = 0
				nextQualityColor = "ItemQuality_Average"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_White"
				contourPower = "CRB_Tooltips:sprTooltip_Header_Silver"
			elseif powerTotal < 15000 then
				powerColor = "ItemQuality_Average"
				nextQuality = 15000
				prevQuality = 10000
				nextQualityColor = "ItemQuality_Good"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_Green"
				contourPower = "CRB_Tooltips:sprTooltip_Header_White"
			elseif powerTotal < 20000 then
				powerColor = "ItemQuality_Good"
				nextQuality = 20000
				prevQuality = 15000
				nextQualityColor = "ItemQuality_Excellent"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_Blue"
				contourPower = "CRB_Tooltips:sprTooltip_Header_Green"
			elseif powerTotal < 30000 then 
				powerColor = "ItemQuality_Excellent"
				nextQuality = 30000
				prevQuality = 20000
				nextQualityColor = "ItemQuality_Superb"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_Purple"
				contourPower = "CRB_Tooltips:sprTooltip_Header_Blue"
			elseif powerTotal < 41000 then
				powerColor = "ItemQuality_Superb"
				nextQuality = 41000
				prevQuality = 30000
				nextQualityColor = "ItemQuality_Legendary"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_Orange"
				contourPower = "CRB_Tooltips:sprTooltip_Header_Purple"
			elseif powerTotal < 46400 then
				powerColor = "ItemQuality_Legendary"
				nextQuality = powerTotal
				nextQualityColor = "ItemQuality_Artifact"
				progressBarStyle = "CRB_Tooltips:sprTooltip_RarityBar_Pink"
				contourPower = "CRB_Tooltips:sprTooltip_Header_Orange"
			else 
				powerColor = "ItemQuality_Artifact"
				progressBarStyle = ""
				contourPower = "CRB_Tooltips:sprTooltip_Header_Pink"
			end
			PowerView.wndCharMini:FindChild("power"):SetText(powerTotal)
			self.wndMain:FindChild("power_total"):SetText("Power : "..powerTotal)
			PowerView.wndMain:FindChild("power_total"):SetTextColor(powerColor)
			PowerView.wndCharMini:FindChild("power"):SetText("Power : "..powerTotal)
			PowerView.wndCharMini:FindChild("contourMini"):SetSprite(contourPower)
			PowerView.wndCharMini:FindChild("power"):SetTextColor(powerColor)
			local powerToNextLevel = nextQuality - powerTotal
			local powerCurrentLevel = powerTotal - prevQuality
			local leftXP, topXP, rightXP, bottomXP = PowerView.wndMain:FindChild("XPBar"):FindChild("XP"):GetAnchorPoints()
			local rightXP = powerCurrentLevel/(nextQuality-prevQuality)
			PowerView.wndMain:FindChild("XPBar"):FindChild("XP"):SetAnchorPoints(leftXP,topXP,rightXP,bottomXP)
			PowerView.wndMain:FindChild("next_power_level"):SetText("Power remaining to next level : "..powerToNextLevel)
			PowerView.wndMain:FindChild("next_power_level"):SetTextColor(nextQualityColor)
			PowerView.wndMain:FindChild("progressBar"):SetSprite(progressBarStyle)
			PowerView.wndMain:FindChild("contourPowerSprite"):SetSprite(contourPower)
			
			--[[targetUnit = GameLib.GetTargetUnit()
			targetItem = targetUnit:GetEquippedItems()
			targetPower = targetItem[1]:GetItemPower()
			PowerView.wndMain:FindChild("item1"):SetText(targetPower)
			]]
			
end

-----------------------------------------------------------------------------------------------
-- PowerViewForm Functions--------------------------------------------------------------------------------------------
-- when the OK button is clicked
function PowerView:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function PowerView:OnCancel()
	self.wndMain:Close() -- hide the window
end
-- Quand le bouton fermer est cliqu 
function PowerView:OnCancelChar()
	self.wndChar:Close() -- ferme la fenetre
end
function PowerView:DisplayPower ()
	local drPlayer = GameLib.GetPlayerUnit()
	local playerName = drPlayer:GetName()
	ChatSystemLib.Command('/g '..playerName.."'s CharPower is "..powerTotal..textChatErrors, "")
end

-----------------------------------------------------------------------------------------------
-- PowerView Instance
-----------------------------------------------------------------------------------------------
local PowerViewInst = PowerView:new()
PowerViewInst:Init()
